## o-saft 22.11.22

=== Makefile ===
#! /usr/bin/make -rRf
#?
#? NAME
#?      Makefile        - makefile for O-Saft project
#?
#? SYNOPSYS
#?      make [options] [target] [...]
#?
#? DESCRIPTION
#?      For help about the targets herein, please see:
#?
#?          make
#?          make help
#?
#?      For detailled documentation how GNU Make, its syntax and conventions as
#?      well as some special syntax of macros and targets is used here,  please
#?      refer to  Makefile.pod , for example by using  "perldoc Makefile.pod" .
#?      The term  "SEE Make:some text"  is used to reference to Makefile.pod .
#
# HACKER's INFO
#       For the public available targets see below of  "well known targets" .
#?
#? VERSION
#?      @(#) Makefile 2.19 22/11/19 00:14:07
#?
#? AUTHOR
#?      21-dec-12 Achim Hoffmann
#?
# -----------------------------------------------------------------------------

_SID            = 2.19
                # define our own SID as variable, if needed ...
                # SEE O-Saft:Makefile Version String
                # Known variables herein (8/2019) to be changed are:
                #     _SID
                #     _INST.text
                #     _INST.is_edit

ALL.includes   := Makefile
                # must be  :=  to avoid overwrite after includes
                # each $(TEST.dir)/Makefile* will add itself to ALL.includes

MAKEFILE        = Makefile
                # define variable for myself,  this allows to use  some targets
                # within other makefiles
                # Note that  $(MAKEFILE) is used where any Makefile is possible
                # and  Makefile  is used when exactly this file is meant.
                # $(ALL.Makefiles) is used, when all Makefiles are needed.

MAKEFLAGS       = --no-builtin-variables --no-builtin-rules
.SUFFIXES:

.DEFAULT:
	@echo "**ERROR: unknown target '$(MAKECMDGOALS)'"

first-target-is-default: help

#_____________________________________________________________________________
#________________________________________________________________ variables __|

Project         = o-saft
ProjectName     = O-Saft
INSTALL.dir     = /usr/local/$(Project)

# tool source files
SRC.lic         = yeast.lic
DEV.pl          = yeast.pl
CHK.pl          = checkAllCiphers.pl
OSD.dir         = OSaft/Doc
OSD.pm          = OSaft/Doc/Data.pm
OSD.txt         = \
		  coding.txt \
		  glossary.txt \
		  help.txt \
		  links.txt \
		  misc.txt \
		  rfc.txt \
		  tools.txt
SRC.txt         = $(OSD.txt:%=$(OSD.dir)/%)
NET.pm          = SSLinfo.pm \
		  SSLhello.pm
OSAFT.pm        = Ciphers.pm Data.pm Text.pm error_handler.pm
USR.pm          = \
		  $(Project)-dbx.pm \
		  $(Project)-man.pm \
		  $(Project)-usr.pm
SRC.pm          = \
		  osaft.pm \
		  $(NET.pm:%=Net/%)   \
		  $(OSAFT.pm:%=OSaft/%) \
		  $(USR.pm) \
		  $(OSD.pm)
SRC.sh          = $(Project)
SRC.pl          = $(Project).pl
SRC.tcl         = $(Project).tcl
SRC.gui         = $(Project).tcl $(Project)-img.tcl
SRC.cgi         = $(Project).cgi
SRC.php         = $(Project).php
SRC.docker      = \
		  $(Project)-docker \
		  $(Project)-docker-dev \
		  Dockerfile
SRC.rc          = .$(SRC.pl)

SRC.exe         = $(SRC.pl) $(SRC.gui) $(CHK.pl) $(DEV.pl) $(SRC.sh)

SRC.make        = Makefile
SRC.misc        = README.md CHANGES
SRC.inst        = $(SRC.contrib.dir)/INSTALL-template.sh

# contrib files
SRC.contrib.dir     = contrib
SRC.contrib.examples= filter_examples usage_examples
SRC.contrib.post.awk= \
		  Cert-beautify.awk \
		  HTML-simple.awk   HTML-table.awk \
		  JSON-struct.awk   JSON-array.awk \
		  XML-attribute.awk XML-value.awk \
		  lazy_checks.awk
SRC.contrib.post    = \
		  Cert-beautify.pl \
		  alertscript.pl \
		  alertscript.cfg \
		  bunt.pl \
		  bunt.sh \
		  symbol.pl
SRC.contrib.misc    = \
		  cipher_check.sh \
		  critic.sh \
		  gen_standalone.sh \
		  distribution_install.sh \
		  install_openssl.sh \
		  install_perl_modules.pl \
		  INSTALL-template.sh \
		  Dockerfile.alpine-3.6

SRC.contrib.zap     = zap_config.sh zap_config.xml
# some file should get the $(Project) suffix, which is appended later
SRC.contrib.complete= \
		  bash_completion \
		  dash_completion \
		  fish_completion \
		  tcsh_completion
SRC.contrib     = \
		  $(SRC.contrib.complete:%=$(SRC.contrib.dir)/%_$(Project)) \
		  $(SRC.contrib.examples:%=$(SRC.contrib.dir)/%) \
		  $(SRC.contrib.post.awk:%=$(SRC.contrib.dir)/%) \
		  $(SRC.contrib.post:%=$(SRC.contrib.dir)/%) \
		  $(SRC.contrib.misc:%=$(SRC.contrib.dir)/%) \
		  $(SRC.contrib.zap:%=$(SRC.contrib.dir)/%)


TEST.dir        = t
TEST.logdir     = $(TEST.dir)/log
TEST.do         = SSLinfo.pl \
                  o-saft_bench.sh \
                  cloc-total.awk \
                  critic_345.sh \
                  test-bunt.pl.txt
TEST.critic.rc  = .perlcriticrc
SRC.test        = \
                  $(TEST.do:%=$(TEST.dir)/%) \
                  $(TEST.critic.rc:%=$(TEST.dir)/%)
TEST.Makefiles   = \
		  Makefile         Makefile.inc   Makefile.help  Makefile.pod \
		  Makefile.gen \
		  Makefile.opt     Makefile.cmd   Makefile.ext   Makefile.exit \
		  Makefile.cgi     Makefile.tcl   Makefile.misc  Makefile.warnings \
		  Makefile.critic  Makefile.dev   Makefile.etc   Makefile.template \
		  Makefile.docker  Makefile.FQDN  Makefile.examples
SRC.Makefiles   = $(TEST.Makefiles:%=$(TEST.dir)/%)

# documentation files
DOC.dir         = docs
DOC.src         = o-saft_CLI_data_flow.odg \
		  o-saft_GUI_data_flow.odg \
		  o-saft_docker.de.odg \
		  o-saft_docker.en.odg
SRC.doc         = $(DOC.src:%=$(DOC.dir)/%)
WEB.dir         = docs/img
WEB.src         = \
		  img.css \
		  O-Saft_CLI-cipher.png \
		  O-Saft_CLI-altname.png \
		  O-Saft_GUI-altname.png \
		  O-Saft_GUI-check.png \
		  O-Saft_GUI-cmd--docker.png \
		  O-Saft_GUI-cmd.png \
		  O-Saft_GUI-cmd-0.png \
		  O-Saft_GUI-filter.png \
		  O-Saft_GUI-help-0.png \
		  O-Saft_GUI-help-1.png \
		  O-Saft_GUI-opt.png \
		  O-Saft_GUI-prot.png \
		  O-Saft_GUI-vulns.png \
		  O-Saft_CLI-vulns.png \
		  O-Saft_CLI__faked.txt
SRC.web         = $(WEB.src:%=$(WEB.dir)/%)

# generated files
TMP.dir         = /tmp/$(Project)
GEN.html        = $(DOC.dir)/$(Project).html
GEN.cgi.html    = $(DOC.dir)/$(Project).cgi.html
GEN.text        = $(DOC.dir)/$(Project).txt
GEN.wiki        = $(DOC.dir)/$(Project).wiki
GEN.man         = $(DOC.dir)/$(Project).1
GEN.pod         = $(DOC.dir)/$(Project).pod
GEN.src         = $(SRC.contrib.dir)/$(Project)-standalone.pl
GEN.pdf         = $(SRC.doc:%.odg=%.pdf)
GEN.inst        = INSTALL.sh
GEN.tags        = tags
GEN.rel         = $(Project).rel

GEN.tgz         = $(Project).tgz
GEN.tmptgz      = $(TMP.dir)/$(GEN.tgz)

# generated files for internal use, i.e. $(SRC.tcl)
# TODO: because make does not allow = in target names, the generated targets
#       should use - instead
LIST.DOC_data   = --help --help=opts --help=commands --help=glossar --help=alias \
		  --help=data --help=data --help=checks --help=regex --help=rfc \
		  --help=ciphers-html --help=ciphers-text
# --help=warnings  uses a different command to be generated
GEN.DOC.data    = $(LIST.DOC_data:%=$(DOC.dir)/$(SRC.pl).%)
GEN.DOC.data   += $(DOC.dir)/$(SRC.pl).--help=warnings

# summary variables
GEN.docs        = $(GEN.pod) $(GEN.html) $(GEN.cgi.html) $(GEN.text) $(GEN.wiki) $(GEN.man)
# NOTE: sequence in ALL.Makefiles is important, for example when used in target doc
ALL.Makefiles   = $(SRC.make) $(SRC.Makefiles)
ALL.osaft       = $(SRC.pl)  $(SRC.gui) $(CHK.pl)  $(SRC.pm)  $(SRC.sh) $(SRC.txt) $(SRC.rc) $(SRC.docker)
ALL.exe         = $(SRC.exe) $(SRC.cgi) $(SRC.php) $(GEN.src) $(SRC.docker)
ALL.tst         = $(SRC.test)
ALL.contrib     = $(SRC.contrib)
ALL.doc         = $(SRC.doc) $(SRC.web)
ALL.pm          = $(SRC.pm)
ALL.gen         = $(GEN.src) $(GEN.docs) $(GEN.DOC.data)
ALL.docs        = $(SRC.doc) $(GEN.docs)
    # NOTE: ALL.docs are the files for user documentation, ALL.doc are SRC-files
    #       $(GEN.wiki) is rarley used but part of ALL.gen for simplicity
#               # $(GEN.tags) added in t/Makefile.misc
ALL.src         = \
		  $(ALL.exe) \
		  $(ALL.pm) \
		  $(SRC.txt) \
		  $(SRC.rc) \
		  $(SRC.misc) \
		  $(SRC.doc) \
		  $(ALL.gen) \
		  $(ALL.Makefiles) \
		  $(ALL.tst) \
		  $(ALL.contrib)
ALL.tgz         = $(ALL.src:%=O-Saft/%)
ALL.tgz        += O-Saft/$(GEN.inst)

# internal used make
MAKE            = $(MAKE_COMMAND)
# some rules need to have a command, otherwise they are not evaluated
EXE.dummy       = /bin/echo -n ""
# internal used tools (paths hardcoded!)
EXE.single      = contrib/gen_standalone.sh
EXE.docker      = o-saft-docker
EXE.pl          = $(SRC.pl)
#                   SRC.pl is used for generating a couple of data

# other tools
EXE.office      = libreoffice

# summary variables (mainly used for INSTALL.sh)
_ALL.devtools.intern  += $(EXE.single)
_ALL.devtools.extern  += sccs gpg sha256sum docker
ALL.tools.optional     = aha perldoc pod2html pod2man pod2pdf pod2text pod2usage podman podviewer tkpod stty tput
ALL.perlmodules = Net::DNS Net::SSLeay IO::Socket::INET IO::Socket::SSL Time::Local
ALL.devtools    = $(_ALL.devtools.intern)   $(_ALL.devtools.extern)
ALL.devmodules  = $(_ALL.devmodules.intern) $(_ALL.devmodules.extern)
#                 defined in t/Makefile.misc
ALL.osaftmodules= osaft $(NET.pm:%.pm=Net::%) $(OSAFT.pm:%.pm=OSaft::%) OSaft::Doc::Data

# following for documentation, not yet used (2022)
#_ALL.tools.dbian.pkg  = aha libtk-pod-perl perl-doc perl-doc-html pod2pdf

# INSTALL.sh must not contain duplicate files, hence the variable's content
# is sorted using make's built-in sort which removes duplicates
_INST.osaft_cgi = $(sort $(SRC.cgi) $(SRC.php) $(GEN.cgi.html))
_INST.osaft_doc = $(sort $(GEN.pod) $(GEN.man) $(GEN.html))
_INST.contrib   = $(sort $(ALL.contrib))
_INST.osaft     = $(sort $(ALL.osaft))
_INST.devtools  = $(sort $(ALL.devtools))
_INST.tools_int = $(sort $(_ALL.devtools.intern))
_INST.tools_ext = $(sort $(_ALL.devtools.extern))
_INST.tools_opt = $(sort $(ALL.tools.optional))
_INST.tools_other = $(sort $(ALL.tools.ssl))
_INST.devmodules= $(sort $(ALL.devmodules))
_INST.genbytext = generated data by Makefile 2.19 from $(SRC.inst)
_INST.gen_text  = generated data from Makefile 2.19
EXE.install = sed -e 's@INSERTED_BY_MAKE_INSTALLDIR@$(INSTALL.dir)@'         \
		  -e 's@INSERTED_BY_MAKE_CONTRIBDIR@$(SRC.contrib.dir)@'     \
		  -e 's@INSERTED_BY_MAKE_CONTRIB@$(_INST.contrib)@'          \
		  -e 's@INSERTED_BY_MAKE_TOOLS_OTHER@$(_INST.tools_other)@'  \
		  -e 's@INSERTED_BY_MAKE_TOOLS_OPT@$(_INST.tools_opt)@'      \
		  -e 's@INSERTED_BY_MAKE_DEVTOOLSINT@$(_INST.tools_int)@'    \
		  -e 's@INSERTED_BY_MAKE_DEVTOOLSEXT@$(_INST.tools_ext)@'    \
		  -e 's@INSERTED_BY_MAKE_DEVMODULES@$(_INST.devmodules)@'    \
		  -e 's@INSERTED_BY_MAKE_PERL_MODULES@$(ALL.perlmodules)@'   \
		  -e 's@INSERTED_BY_MAKE_OSAFT_SH@$(SRC.sh)@'                \
		  -e 's@INSERTED_BY_MAKE_OSAFT_PL@$(SRC.pl)@'                \
		  -e 's@INSERTED_BY_MAKE_OSAFT_GUI@$(SRC.tcl)@'              \
		  -e 's@INSERTED_BY_MAKE_OSAFT_CGI@$(_INST.osaft_cgi)@'      \
		  -e 's@INSERTED_BY_MAKE_OSAFT_STAND@$(GEN.src)@'            \
		  -e 's@INSERTED_BY_MAKE_OSAFT_DOCKER@$(EXE.docker)@'        \
		  -e 's@INSERTED_BY_MAKE_OSAFT_DOC@$(_INST.osaft_doc)@'      \
		  -e 's@INSERTED_BY_MAKE_OSAFT_MODULES@$(ALL.osaftmodules)@' \
		  -e 's@INSERTED_BY_MAKE_OSAFT@$(_INST.osaft)@'              \
		  -e 's@INSERTED_BY_MAKE_FROM@$(_INST.genbytext)@'           \
		  -e 's@INSERTED_BY_MAKE@$(_INST.gen_text)@'
                # note that the sequence of the -e commands is important
                # last substitude is fallback to ensure everything is changed

# generate f- targets to print HELP text for each target
_HELP.my_targets= $(shell $(EXE.eval) $(MAKEFILE))
_HELP.alltargets= $(shell $(EXE.eval) $(ALL.includes))
_HELP.help      = $(ALL.help:%=f-%)
                # quick&dirty because each target calls make (see below)

=== t/Makefile ===
#! /usr/bin/make -rRf
#?
#? NAME
#?      Makefile        - makefile for testing O-Saft
#?
#? SYNOPSYS
#?      make [options] [target] [...]
#?
#? DESCRIPTION
#?      For more details please see
#?          ../Makefile  Makefile.help  Makefile.pod
#?      make help.test
#?
# HACKER's INFO
#       For details please see
#           ../Makefile  Makefile.help  Makefile.template
#
#    Naming conventions for t/Makefile*
#       * variable names have the prefix  TEST  and  HELP .
#       * target names for public use have the prefix  test.
#       * individual, special targets have the prefix  _test (exceptions exist)
#
#    Summary variables extended in each t/Makefile*
#       ALL.includes    - list of Makefiles
#       ALL.inc.type    - list of types (should be suffix of Makefile's name)
#       ALL.help.tests  - list of documentation (help) texts
#       ALL.tests       - list of targets for testing
#       ALL.tests.log   - list of targets for testing writing to logfile
#
#    Variables specific for each t/Makefile*
#       _SID.myTYPE     - version number
#       _MYSELF.myTYPE  - name of current file
#       HELP.myTYPE     - documentation (help) text for the corresponding file
#       HELP.myTYPE.all - list of all targets for the corresponding file
#       HELP.myTYPE.internal  - some more documentation (help) text
#           where  myTYPE  above is the suffix of the Makefile's filename
#
#    Each t/Makefile* may also redefine following variables
#       HELP_TYPE       - suffix (and type) of Makefile*
#       HELP_HEAD       - descriptive header line, set to HELP_NAME, HELP_RULE 
#
#    Special targets for documentation (help) in t/Makefile*
#       help.test.%     - print individual documentation using $(HELP.myTYPE)
#       help.test.%.all - print all targets using $(HELP.myTYPE.all)
#       help.test.%.internal - print details using $(HELP.myTYPE.internal)
#           where  %  is the suffix of the Makefile's filename
#
#       TODO:
#          * include Makefile.* should be generic
#          * unify test.warnings.log and test.tests.log (should use same target)
#          * rename ALL.tests and ALL.tests.log (too similar to ALL.test)
#
#? VERSION
#?      @(#) Makefile 1.142 22/11/13 13:26:27
#?
#? AUTHOR
#?      18-apr-18 Achim Hoffmann
#?
# -----------------------------------------------------------------------------

HELP-help.test.test = general testing targets

_SID.test          := 1.142

_MYSELF.test       := t/Makefile
ALL.includes       += $(_MYSELF.test)
ALL.inc.type       += test
ALL.help.tests     += help.test

export OSAFT_MAKE  := avoid writing random data (like date and time string)
export LANG        := C
    # LANG ensures same messages and sorting everywhere  

first-test-target-is-default: help.test

ifndef ALL.Makefiles
    -include t/Makefile.inc
    # defines variables if called directly (not from ../Makefile)
endif

help.test:            HELP_TYPE = test
help.test-v:          HELP_TYPE = test
help.test-vv:         HELP_TYPE = test
help.test.all:        HELP_TYPE = test
help.test.test:       HELP_TYPE = test
help.test.test-v:     HELP_TYPE = test
help.test.test-vv:    HELP_TYPE = test
help.test.test.all:   HELP_TYPE = test
help.test:            HELP_HEAD = $(HELP_RULE)
help.test.%:          HELP_HEAD = $(HELP_RULE)

#_____________________________________________________________________________
#________________________________________________________________ variables __|

ifndef test-remove-environment-variables
    # most environment variables should be ignored,  to avoid unexpected
    # behaviour and to keep our list of variables clean;
    # forst define list of required variables, then get list of existing
    # environment variable and remove all except the required ones
    $(eval _keep = OSAFT_MAKE   LANG \
        DISPLAY HOME    PATH    PWD     SHELL   TERM    USER    NLSPATH \
        DT_RUNPATH      DT_RPATH DT_NEEDED \
        DYLD_LIBRARY_PATH   DYLD_FALLBACK_LIBRARY_PATH \
        LD_CONFIG       LD_LIBRARY_PATH LD_PRELOAD      LD_RUN_PATH LD_DEBUG \
        LD_TRACE_LOADED_OBJECTS   LD_TRACE_LOADED_OBJECTS_ALL LD_TRACE_PRELINKING \
        LIBPATH RPATH   RUNPATH   SHLIB_PATH  \
        OPENSSL_CONF    OPENSSL_FIPS    OPENSSL_ENGINES OPENSSL \
        OPENSSL_ALLOW_PROXY OPENSSL_ALLOW_PROXY_CERTS \
    )
    $(eval _env  = $(shell printenv | awk -F= '{print $$1}'))
    $(foreach _var, $(filter-out $(_keep),$(_env)), $(eval undefine $(_var)))
    $(eval undefine _keep)
    $(eval undefine _env)
    test-remove-environment-variables = done
endif

# store -n (dry-run) option in own variable
TEST.make-n    := $(if $(findstring n,$(firstword -$(MAKEFLAGS))),-n)

# internal variables
TEST.dir       := t
TEST.logdir     = $(TEST.dir)/log
TEST.logtxt    := <<random value replaced by make>>
TEST.symlinks  := ../contrib ../osaft.pm ../.o-saft.pl ../Net ../docs ../OSaft

# following may be redefined in included t/Makefile*
#TEST.init      := --header
#TEST.args      :=

# variable for list of hostnames needs to be unique in each Makefile*
# otherwise some targets in other Makefile* get confused
#TEST.host       = localhost
#TEST.hosts      =

# following defined in ../Makefile
# TEST.do  =
# SRC.test =
# ALL.test =

# defined in other t/Makefile*
# ALL.tests =

#  $(SRC.rc)  may not be defined here, hence hardcoded

ifndef SRC.contrib.dir
    SRC.contrib.dir = contrib
endif

# Tracing just the log-targets is special. Using  $(TRACE.target)  is not an
# option, because it would als change the final target called with  $(MAKE) .
# Hence an additional variable is used.
# TODO: not public, not documented, variable needs to be defined here
TRACE.target.log    =
    #  example  = echo "\# $*\tcalling: $(MAKE) -s testcmd-$*"

TEST.today         := $(shell date +%Y""%m%d)
    # current date in ISO format

# need a usable way to change diff program; EXE.diff may be set on command-line
EXE.log-diff       := diff
EXE.log-xxdiff     := xxdiff --geometry 1600x1000
EXE.log-mgdiff     := mgdiff
EXE.log-tkdiff     := tkdiff
EXE.diffs          := diff xxdiff mgdiff tkdiff
EXE.diff           := tkdiff
EXE.log-diff        = $(EXE.log-tkdiff)
    # chaneg EXE.log-diff to use another program

# need a usable way to change generator for man-pages
EXE.gendoc.perldoc := perldoc
EXE.gendoc.pod2man := pod2man
EXE.gendoc         := $(EXE.gendoc.perldoc)

# default filter for testarg-%.log targets
EXE.log-filterarg  := cat
# default filter for testcmd-%.log targets
EXE.log-filtercmd  := cat

_EXE.grep-opt      := -q
    # grep (mainly used in message-% target) should not report matching lines
    # variable can be reset or redifined for more verbose output

_EXE.sort-opt      := -n -f
    # newer GNU sort (~2018) changed the default behaviour, for example
    # case-sensitivity, these options do the traditional sort
    # TODO: need to check first if sort supports these options

_EXE.perldoc-opt   := -n nroff -T
    # newer perldoc prints with plain text format by default
    # -n nroff enforced the traditional behaviour with ASCII-escapes

_EXE.pod2man-opt   := --utf8
    # --date=DATESTRING
    # will be used for testing to avoid diff in generated files

# define script or parts of it as variables, for better human readability
# SEE Make:target matching
#     _EXE.macro_by_line.awk    - extract all variable names
#     _EXE.target_by_line.awk   - extract all target names
#     _EXE.target_to_arr.awk    - extract target names and store uniquely in arr[]
#     _EXE.print_arr_END.awk    - print collected data from arr[]
#     _EXE.print_file.awk       - either print separator line or the filename
TEST.target_prefix :=   [a-zA-Z][_a-zA-Z.]
   # matching target names not starting with _
_EXE.macro_by_line.awk := /^[a-zA-Z_][a-zA-Z_.]* *=/{sub(/=/,"",$$1);print $$1}
_EXE.target_by_line.awk:= /^[a-zA-Z_][a-zA-Z_.]* *:/{sub(/:/,"",$$1);print $$1}
_EXE.target_to_arr.awk  = /^.*%/{next} /^$(TEST.target_prefix)*/{arr[$$1]=1}
_EXE.print_arr_END.awk := END{for(idx in arr){print idx}}
_EXE.print_file.awk    := (FNR==1){ x="";for(i=1;i<62;i++){x=sprintf("%s%c",x,"-")};print "\n\t\t\#"x}

# if target was test*-compare-v or test*-move-v  TRACE.target  is not empty, so
# checking this variable if not empty is sufficent to print verbose information
# not tested if following defines could be written as macros
# SEE Make:defines with commands

define EXE.log-compare
	cd $(TEST.logdir) && \
	echo "# compare "`ls $(TEST.target_prefix)*.log$(TEST.log-suffix) | wc -l`" file ..." && \
	for f in $(TEST.target_prefix)*.log; do \
	    [ -f $${f}$(TEST.log-suffix) ] || continue ; \
	    [ -n '$(TRACE.target)' ] && echo "# $(TEST.logdir)/$${f} ..." ; \
	    $(EXE.log-diff) $${f} $${f}$(TEST.log-suffix) >/dev/null 2>&1 ; \
	done
endef

define EXE.log-compare-hint
	echo ""
	echo "# for informations and to show differences with $(EXE.diff), use:"
	echo "    $(MAKE_COMMAND) help.test.log-info"
	echo "    $(MAKE_COMMAND) $(MAKECMDGOALS)-compare"
	echo "    $(MAKE_COMMAND) $(MAKECMDGOALS)-compare-v"
	echo "    $(MAKE_COMMAND) $(MAKECMDGOALS)-compare TEST.log-suffix=$(TEST.log-suffix)"
endef

define EXE.log-move
	cd $(TEST.logdir) && \
	for f in $(TEST.target_prefix)*.log; do \
	    [ -f $${f}$(TEST.log-suffix) ] || continue ; \
	    [ -n '$(TRACE.target)' ] && echo "# $(TEST.logdir)/$${f} ..." ; \
	    mv $${f}$(TEST.log-suffix) $${f} ; \
	done
endef

# FIXME: does not set _stub properly if $* is set
define EXE.log-move-hint
	_stub="log"
	$(eval _stub="log")
	$(eval $(shell [ -n "$*" ] && _stub="$*.log" ))
	echo ""
	echo "# for informations and to move new files to .log , use:"
	echo "    $(MAKE_COMMAND) help.test.log-info"
	echo "    $(MAKE_COMMAND) test.$(_stub)-move"
	echo "    $(MAKE_COMMAND) test.$(_stub)-move TEST.log-suffix=$(TEST.log-suffix)"
endef


HELP.test       = $(_NL)\
\# The term '%'  in the targets names described here, may be any of:$(_NL)\
\#   $(ALL.inc.type)$(_NL)\
\#$(_NL)\
\# Following variables are intended to be used on command line:$(_NL)\
\#   EXE.pl      - program to perform tests, default: '$(EXE.pl)'$(_NL)\
\#   TEST.init   - arguments and options always passed to EXE.pl; default: '$(TEST.init)'$(_NL)\
\#   TEST.args   - arguments and options to be  passed to EXE.pl per target$(_NL)\
\#   TEST.host   - hostname to be used for tests (when only one is expected)$(_NL)\
\#   TEST.hosts  - list of hostnames to perform tests with$(_NL)\
\#   TEST.dir    - directory in which EXE.pl will be executed; default: '$(TEST.dir)/'$(_NL)\
\#   TEST.logdir - directory where results of EXE.pl will be stored; default: '$(TEST.logdir)/'$(_NL)\
\#   TEST.rc     - content of RC-file to be used by EXE.pl: '$(TEST.rc)'$(_NL)\
\#   TEST.target_prefix - prefix of log-filename; see help.test.log-info$(_NL)\
\#   TEST.log-suffix    - suffix of log-filename; see help.test.log-info$(_NL)\
\#$(_NL)\
\# Notes about some spezial targets:$(_NL)\
\#   help.test   - automatically generated target; alias for help.test.test$(_NL)\
\#   help.test.test.alls -$(_NL)\
\#   help.test.test.all - be prepared for huge output$(_NL)\
\#$(_NL)\
\# Keep in mind that following files are located in '$(TEST.dir)/':$(_NL)\
\#   .o-saft.pl  $(TEST.rc)  .o-saft.tcl$(_NL)\
\# which are used by EXE.pl or other tools used for the tests.

# following variable contains (huge) list of all available targets
HELP.test.test.all  = $(_NL)\
\# $(words $(ALL.tests)) targets for tests:$(_NL)\
$(ALL.tests)$(_NL)\
\#$(_NL)\
\# $(words $(ALL.tests.log)) targets which write results to logfiles:$(_NL)\
$(ALL.tests.log)$(_NL)\
\#$(_NL)\
\# summary targets for tests:$(_NL)\
$(ALL.help.tests:help.%=%)$(_NL)\
\#$(_NL)\
\# for more target and details, following targets can be used$(_NL)\
$(foreach target,$(ALL.inc.type),t-$(target))$(_NL)

HELP.test.test  = $(HELP.test)
HELP.test.all   = $(HELP.test.test.all)
help.test:          help.test.test
help.test.all:      help.test.test.all
	@$(TRACE.target)
# convenience to satisfy  help.test.all

=== debian/changelog ===
o-saft (22.11.22-1) unstable; urgency=medium

  * New upstream version 22.11.22
  * Bump Standards-Version to 4.6.1
  * d/p/install_only_important_files.patch: Update patch

 -- Samuel Henrique <samueloph@debian.org>  Sun, 18 Dec 2022 15:32:13 +0000

=== debian/control ===
Source: o-saft
Section: utils
Priority: optional
Maintainer: Debian Security Tools <team+pkg-security@tracker.debian.org>
Uploaders: Samuel Henrique <samueloph@debian.org>
Build-Depends: bash-completion,
               debhelper-compat (= 13)
Standards-Version: 4.6.1
Rules-Requires-Root: no
Homepage: https://owasp.org/www-project-o-saft/
Vcs-Browser: https://salsa.debian.org/pkg-security-team/o-saft
Vcs-Git: https://salsa.debian.org/pkg-security-team/o-saft.git

Package: o-saft
Architecture: all
Depends: ca-certificates,
         libio-socket-ssl-perl,
         libnet-dns-perl,
         libnet-ssleay-perl,
         libreadonly-perl,
         openssl,
         perl,
         ${misc:Depends}
Recommends: libperl-critic-perl,
            tk (>= 8.5)
Description: SSL advanced forensic tool
 O-Saft is an easy to use tool to show information about SSL certificates and
 tests the SSL connection according to a given list of ciphers and various SSL
 configurations.
 .
 It's designed to be used by penetration testers, security auditors or server
 administrators. The idea is to show the important information or the special
 checks with a simple call of the tool. However, it provides a wide range of
 options so that it can be used for comprehensive and special checks by
 experienced people.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@

# make and make all print a help output only.
# this package only needs the install target.
override_dh_auto_build:
	:

override_dh_auto_test:
	:

override_dh_auto_install:
	mkdir -p debian/o-saft/usr/share/o-saft/
	sh INSTALL.sh debian/o-saft/usr/share/o-saft/
	dh_bash-completion

=== debian/tests/control ===
Test-Command: o-saft +list
Restrictions: superficial
